#ifndef _TASK_Buttons
#define _TASK_Buttons

#include "const.h"
#include "OSA.h"

//------------------------------------------------------------------------------

extern char m_cButtons;
extern char m_cButtonsChanged;
extern char m_cButtonsReleased;

extern OST_SMSG     SMsgButton;

extern bit  m_bButtonPressed;
extern bit  m_bButtonHold;

//------------------------------------------------------------------------------

extern void Task_Buttons(void);

//------------------------------------------------------------------------------


#define BUTTON0_PRESSED     (m_cButtons & 0x01)
#define BUTTON1_PRESSED     (m_cButtons & 0x02)
#define BUTTON2_PRESSED     (m_cButtons & 0x04)
#define BUTTON3_PRESSED     (m_cButtons & 0x08)
#define BUTTON4_PRESSED     (m_cButtons & 0x10)
#define BUTTON5_PRESSED     (m_cButtons & 0x20)
#define BUTTON6_PRESSED     (m_cButtons & 0x40)
#define BUTTON7_PRESSED     (m_cButtons & 0x80)

#define BUTTON0_CHANGED     (m_cButtonsChanged & 0x01)
#define BUTTON1_CHANGED     (m_cButtonsChanged & 0x02)
#define BUTTON2_CHANGED     (m_cButtonsChanged & 0x04)
#define BUTTON3_CHANGED     (m_cButtonsChanged & 0x08)
#define BUTTON4_CHANGED     (m_cButtonsChanged & 0x10)
#define BUTTON5_CHANGED     (m_cButtonsChanged & 0x20)
#define BUTTON6_CHANGED     (m_cButtonsChanged & 0x40)
#define BUTTON7_CHANGED     (m_cButtonsChanged & 0x80)

#define BUTTON0_RELEASED    (m_cButtonsReleased & 0x01)
#define BUTTON1_RELEASED    (m_cButtonsReleased & 0x02)
#define BUTTON2_RELEASED    (m_cButtonsReleased & 0x04)
#define BUTTON3_RELEASED    (m_cButtonsReleased & 0x08)
#define BUTTON4_RELEASED    (m_cButtonsReleased & 0x10)
#define BUTTON5_RELEASED    (m_cButtonsReleased & 0x20)
#define BUTTON6_RELEASED    (m_cButtonsReleased & 0x40)
#define BUTTON7_RELEASED    (m_cButtonsReleased & 0x80)

#define BUTTON0_SHORT       (m_cButtonsReleased & 0x01)
#define BUTTON1_SHORT       (m_cButtonsReleased & 0x02)
#define BUTTON2_SHORT       (m_cButtonsReleased & 0x04)
#define BUTTON3_SHORT       (m_cButtonsReleased & 0x08)
#define BUTTON4_SHORT       (m_cButtonsReleased & 0x10)
#define BUTTON5_SHORT       (m_cButtonsReleased & 0x20)
#define BUTTON6_SHORT       (m_cButtonsReleased & 0x40)
#define BUTTON7_SHORT       (m_cButtonsReleased & 0x80)


//------------------------------------------------------------------------------
// 
//   OSAcfg.h     MSG_BUTTON
//      OS_MESSAGES
enum BUTTON_MESSAGES {
    BUTTON_PRESSED = 1,
    BUTTON_RELEASED,
    BUTTON_HOLD,
    BUTTON_SHORT
};


#endif

